.. _ref_cpp:

===========
C++ Library
===========

Introduction
============

toulbar2 is an open-source C++ solver for cost function networks.

See : :download:`Class Diagram<../../../misc/doc/toulbar2-class.pdf>`.

Main types and constants
========================

.. doxygenfile:: tb2types.hpp
   :sections: detaileddescription

.. doxygenfile:: tb2types.hpp
   :sections: var

WeightedCSP class
=================

.. doxygenclass:: WeightedCSP
   :members:
   :undoc-members:

WeightedCSPSolver class
=======================

.. doxygenclass:: WeightedCSPSolver
   :members:
   :undoc-members:

MultiCFN class
=================

.. doxygenclass:: MultiCFN
   :members:
   :undoc-members:

ToulBar2 class
==============

.. doxygenclass:: ToulBar2
   :members:
   :undoc-members:

Miscellaneous functions
=======================

.. doxygenfunction:: tb2init

.. doxygenfunction:: tb2checkOptions

